
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Service_suitability_rulesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_suitability_rules = await db.service_suitability_rules.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        recommended_signature_level: data.recommended_signature_level
        ||
        null
            ,
            
        enforcement: data.enforcement
        ||
        null
            ,
            
        condition_text: data.condition_text
        ||
        null
            ,
            
        message: data.message
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await service_suitability_rules.setDocument_type( data.document_type || null, {
            transaction,
        });
        
        await service_suitability_rules.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return service_suitability_rules;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const service_suitability_rulesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                recommended_signature_level: item.recommended_signature_level
            ||
            null
            ,
            
                enforcement: item.enforcement
            ||
            null
            ,
            
                condition_text: item.condition_text
            ||
            null
            ,
            
                message: item.message
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const service_suitability_rules = await db.service_suitability_rules.bulkCreate(service_suitability_rulesData, { transaction });

        // For each item created, replace relation files
        

        return service_suitability_rules;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const service_suitability_rules = await db.service_suitability_rules.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.recommended_signature_level !== undefined) updatePayload.recommended_signature_level = data.recommended_signature_level;
        
        
        if (data.enforcement !== undefined) updatePayload.enforcement = data.enforcement;
        
        
        if (data.condition_text !== undefined) updatePayload.condition_text = data.condition_text;
        
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await service_suitability_rules.update(updatePayload, {transaction});

        
        
        if (data.document_type !== undefined) {
            await service_suitability_rules.setDocument_type(
              
              data.document_type,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await service_suitability_rules.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return service_suitability_rules;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_suitability_rules = await db.service_suitability_rules.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of service_suitability_rules) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of service_suitability_rules) {
                await record.destroy({transaction});
            }
        });


        return service_suitability_rules;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const service_suitability_rules = await db.service_suitability_rules.findByPk(id, options);

        await service_suitability_rules.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await service_suitability_rules.destroy({
            transaction
        });

        return service_suitability_rules;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const service_suitability_rules = await db.service_suitability_rules.findOne(
            { where },
            { transaction },
        );

        if (!service_suitability_rules) {
            return service_suitability_rules;
        }

        const output = service_suitability_rules.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.document_type = await service_suitability_rules.getDocument_type({
            transaction
        });
        
        
        output.organizations = await service_suitability_rules.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.document_types,
        as: 'document_type',
        
        where: filter.document_type ? {
          [Op.or]: [
            { id: { [Op.in]: filter.document_type.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.document_type.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_suitability_rules',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.condition_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_suitability_rules',
                        'condition_text',
                        filter.condition_text,
                    ),
                };
            }
            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_suitability_rules',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.recommended_signature_level) {
                where = {
                    ...where,
                recommended_signature_level: filter.recommended_signature_level,
            };
            }
            
            if (filter.enforcement) {
                where = {
                    ...where,
                enforcement: filter.enforcement,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.service_suitability_rules.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'service_suitability_rules',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.service_suitability_rules.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

